VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
Private mWndProcOrg As Long
Private mHWndSubClassed As Long
Private m_sName As String
Private m_iArrange As Long
Private m_oForm As tasks.frmPlugin
Private tasks() As Long
Private mlngTimerID As Long
Private Function IBasePlugin_StartPlugin(name As String) As Long
    
    Dim mm As MINIMIZEDMETRICS
    Dim ErrNum As Integer
    Dim hwcurr As Long
    Dim textline As String
    
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang name, "!refresh"
    oServer.RegisterBang name, "!hide"
    oServer.RegisterBang name, "!show"
    oServer.RegisterBang name, "!toggle"
    
    ' to recieve shell messages we need to register the !hshell bang
    oServer.RegisterBang name, "!hshell"
    
    mm.cbSize = Len(mm)
    ErrNum = SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Get " & CStr(ErrNum)
    End If
    m_iArrange = mm.iArrange
    mm.iArrange = 8 'mm.iArrange Xor 8
    mm.iWidth = 0
    ErrNum = SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Set " & CStr(ErrNum)
    End If
    
    m_sName = name
    Set m_oForm = New tasks.frmPlugin
    Call Load(m_oForm)
    
    m_oForm.Tag = m_sName
    m_oForm.Caption = m_sName
    m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "X")) * Screen.TwipsPerPixelX
    m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "Y")) * Screen.TwipsPerPixelY
    
    m_oForm.picTasks(0).Height = oServer.evalNum(oServer.GetKey(m_sName, "TileHeight"))
    m_oForm.picTasks(0).Width = oServer.evalNum(oServer.GetKey(m_sName, "TileWidth"))
    m_oForm.TileBackground = oServer.GetKey(m_sName, "TileBackground")
    m_oForm.Height = m_oForm.picTasks(0).Height * Screen.TwipsPerPixelY
    m_oForm.picTasks(0).Left = -m_oForm.picTasks(0).Width
    textline = oServer.GetKey(m_sName, "Background")
    If textline <> "" Then
        m_oForm.Picture = LoadPicture(textline)
    Else
        oServer.Execute "!log Error: tasks module couldn't find a image to use as its background"
    End If
    If oServer.evalBool(oServer.GetKey(m_sName, "AlwaysOnTop")) Then
        SetWindowPos m_oForm.hwnd, HWND_TOPMOST, m_oForm.Left / Screen.TwipsPerPixelX, m_oForm.Top / Screen.TwipsPerPixelY, m_oForm.Width / Screen.TwipsPerPixelX, m_oForm.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
    End If
    m_oForm.setup
    
    ReDim tasks(0)
    hwcurr = GetWindow(m_oForm.hwnd, GW_HWNDFIRST)
    Do While hwcurr
        If hwcurr <> m_oForm.hwnd And TaskWindow(hwcurr) Then
            addTask hwcurr
            m_oForm.picTasks_Paint m_oForm.picTasks.Count - 1
        End If
        hwcurr = GetWindow(hwcurr, GW_HWNDNEXT)
    Loop
    
    m_oForm.Show
    IBasePlugin_StartPlugin = m_oForm.hwnd

End Function
Private Sub IBasePlugin_StopPlugin()

    Dim mm As MINIMIZEDMETRICS
    Dim ErrNum As Integer
    
    m_oForm.Visible = False
    Call Unload(m_oForm)
    Set m_oForm = Nothing
    mm.cbSize = Len(mm)
    ErrNum = SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Get " & CStr(ErrNum)
    End If
    mm.iArrange = m_iArrange
    mm.iWidth = 0
    ErrNum = SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, Len(mm), mm, 0)
    If ErrNum = 0 Then
        ErrNum = GetLastError
        oServer.Execute "!log tasks - error: Failed Set " & CStr(ErrNum)
    End If

End Sub
Private Sub IBasePlugin_Bang(ByVal name As String, ByVal Arguments As String)
    
    Dim hCommand As String
    Dim hParamter As String
    Dim i As Integer
    Dim j As Integer
    Dim hwnd As Long
    Dim textline As String
    Dim hwcurr As Long
    Dim temp As Long
    
    Select Case name
    Case "!refresh"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = False
            Call Unload(m_oForm)
            Set m_oForm = Nothing
            Set m_oForm = New tasks.frmPlugin
            Call Load(m_oForm)
            
            m_oForm.Tag = m_sName
            m_oForm.Caption = m_sName
            m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "X")) * Screen.TwipsPerPixelX
            m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "Y")) * Screen.TwipsPerPixelY
            
            m_oForm.picTasks(0).Height = oServer.evalNum(oServer.GetKey(m_sName, "TileHeight"))
            m_oForm.picTasks(0).Width = oServer.evalNum(oServer.GetKey(m_sName, "TileWidth"))
            m_oForm.TileBackground = oServer.GetKey(m_sName, "TileBackground")
            m_oForm.Height = m_oForm.picTasks(0).Height * Screen.TwipsPerPixelY
            m_oForm.picTasks(0).Left = -m_oForm.picTasks(0).Width
            textline = oServer.GetKey(m_sName, "Background")
            If textline <> "" Then
                m_oForm.Picture = LoadPicture(textline)
            Else
                oServer.Execute "!log Error: tasks module couldn't find a image to use as its background"
            End If
            If oServer.evalBool(oServer.GetKey(m_sName, "AlwaysOnTop")) Then
                SetWindowPos m_oForm.hwnd, HWND_TOPMOST, m_oForm.Left / Screen.TwipsPerPixelX, m_oForm.Top / Screen.TwipsPerPixelY, m_oForm.Width / Screen.TwipsPerPixelX, m_oForm.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
            End If
            m_oForm.setup
            
            ReDim tasks(0)
            hwcurr = GetWindow(m_oForm.hwnd, GW_HWNDFIRST)
            Do While hwcurr
                If hwcurr <> m_oForm.hwnd And TaskWindow(hwcurr) Then
                    addTask hwcurr
                    m_oForm.picTasks_Paint m_oForm.picTasks.Count - 1
                End If
                hwcurr = GetWindow(hwcurr, GW_HWNDNEXT)
            Loop
            m_oForm.Show
        End If
    Case "!hide"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = False
        End If
    Case "!show"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = True
            If oServer.evalBool(oServer.GetKey(m_sName, "alwaysontop")) Then
                SetWindowPos m_oForm.hwnd, HWND_TOPMOST, m_oForm.Left / Screen.TwipsPerPixelX, m_oForm.Top / Screen.TwipsPerPixelY, m_oForm.Width / Screen.TwipsPerPixelX, m_oForm.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
            End If
            m_oForm.Left = oServer.evalNum(oServer.GetKey(m_sName, "x")) * Screen.TwipsPerPixelX
            m_oForm.Top = oServer.evalNum(oServer.GetKey(m_sName, "y")) * Screen.TwipsPerPixelY
        End If
    Case "!toggle"
        If LCase(Arguments) = LCase(m_sName) Or LCase(Arguments) = LCase("*") Then
            m_oForm.Visible = Not m_oForm.Visible
        End If
    Case "!hshell"
        hCommand = Left(Arguments, InStr(Arguments, " ") - 1)
        hParamter = Right(Arguments, Len(Arguments) - InStr(Arguments, " "))
        Select Case UCase(hCommand)
        Case "FLASH"
            If TaskWindow(CLng(hParamter)) Then
                i = 0
                While CLng(m_oForm.picTasks(i).Tag) <> CLng(hParamter) And i < m_oForm.picTasks.Count - 1
                    i = i + 1
                Wend
                m_oForm.FlashTask i
            End If
        Case "WINDOWCREATED"
            If TaskWindow(CLng(hParamter)) Then
                addTask CLng(hParamter)
            End If
            refreshTasks
        Case "WINDOWDESTROYED"
            removeTask CLng(hParamter)
            refreshTasks
            
        Case "WINDOWACTIVATED"
            hwnd = CLng(hParamter)
            If TaskWindow(hwnd) Then

                ' Unmark the old active tile
                i = 0
                While CLng(m_oForm.picTasks(i).Tag) <> m_oForm.CurAct And i < m_oForm.picTasks.Count - 1
                    i = i + 1
                Wend
                If CLng(m_oForm.picTasks(i).Tag) = m_oForm.CurAct Then
                    m_oForm.CurAct = 0
                    m_oForm.picTasks_Paint i
                End If

                i = GetParent(hwnd)
                While i > 0
                    hwnd = i
                    i = GetParent(hwnd)
                Wend

                ' mark the new active tile
                i = 0
                While CLng(m_oForm.picTasks(i).Tag) <> hwnd And i < m_oForm.picTasks.Count - 1
                    i = i + 1
                Wend
                If CLng(m_oForm.picTasks(i).Tag) = hwnd Then
                    m_oForm.CurAct = hwnd
                    m_oForm.picTasks_Paint i
                End If
                
            End If
        Case "REDRAW"
            If TaskWindow(CLng(hParamter)) Then
                i = 0
                While CLng(m_oForm.picTasks(i).Tag) <> CLng(hParamter) And i < m_oForm.picTasks.Count - 1
                    i = i + 1
                Wend
                m_oForm.picTasks_Paint i
            End If
        End Select
    End Select

End Sub
Private Property Get IBasePlugin_Name() As String

    IBasePlugin_Name = m_sName

End Property
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Function TaskWindow(hwnd As Long) As Long
    
    
    Dim nStyle      As Long
    Dim hOwner      As Long
    Dim hParent     As Long
    Dim bResult     As Boolean
    Dim intLen      As Integer
    Dim strTitle      As String
    
    ' This is based on juggs code, which in turn was based on re5ource popup code
    bResult = True


    nStyle = GetWindowLong(hwnd, GWL_STYLE)
    If ((nStyle And WS_CHILD)) Or ((nStyle And WS_VISIBLE) = 0) Or (IsWindowVisible(hwnd) = 0) Or (IsWindow(hwnd) = 0) Then
        bResult = False
    End If

    nStyle = GetWindowLong(hwnd, GWL_EXSTYLE)
    If (nStyle And WS_EX_TOOLWINDOW) Or ((nStyle And WS_EX_WINDOWEDGE) = 0) Then
        bResult = False
    End If

    hOwner = GetWindow(hwnd, GW_OWNER)
    If (hOwner And bResult) Then
        bResult = Not TaskWindow(hOwner)
    End If

    hParent = GetParent(hwnd)
    If (hParent) Then
        bResult = False
    End If

    TaskWindow = bResult

End Function
Private Sub addTask(hwnd As Long)
    
    Dim i As Long
    
    If Not existTask(hwnd) Then
    
        Load m_oForm.picTasks(m_oForm.picTasks.Count)
        m_oForm.picTasks(m_oForm.picTasks.Count - 1).Tag = hwnd
        
        If m_oForm.picTasks.Count = 2 Then
            m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.BorderTop
            m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.BorderLeft
        Else
            If ((m_oForm.picTasks.Count - 2) Mod m_oForm.wrapcount = 0) Then
                Select Case LCase(m_oForm.wrapdirection)
                Case "up"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Top - m_oForm.picTasks(m_oForm.picTasks.Count - 2).Height - m_oForm.TileSpaceY
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.BorderLeft
                Case "down"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Top + m_oForm.picTasks(m_oForm.picTasks.Count - 2).Height + m_oForm.TileSpaceY
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.BorderLeft
                Case "left"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Left + m_oForm.picTasks(m_oForm.picTasks.Count - 2).Width + m_oForm.TileSpaceX
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.BorderTop
                Case "right"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Left - m_oForm.picTasks(m_oForm.picTasks.Count - 2).Width - m_oForm.TileSpaceX
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.BorderTop
                
                End Select
            Else
                Select Case LCase(m_oForm.direction)
                Case "up"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Top - m_oForm.picTasks(m_oForm.picTasks.Count - 2).Height - m_oForm.TileSpaceY
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Left
                Case "down"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Top + m_oForm.picTasks(m_oForm.picTasks.Count - 2).Height + m_oForm.TileSpaceY
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Left
                Case "left"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Left + m_oForm.picTasks(m_oForm.picTasks.Count - 2).Width + m_oForm.TileSpaceX
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Top
                Case "right"
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Left = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Left - m_oForm.picTasks(m_oForm.picTasks.Count - 2).Width - m_oForm.TileSpaceX
                    m_oForm.picTasks(m_oForm.picTasks.Count - 1).Top = m_oForm.picTasks(m_oForm.picTasks.Count - 2).Top
                End Select
            End If
        End If
        m_oForm.picTasks(m_oForm.picTasks.Count - 1).Visible = True
        m_oForm.picTasks_Paint m_oForm.picTasks.Count - 1
    
        m_oForm.maxY = 0
        m_oForm.maxX = 0
        For i = 1 To m_oForm.picTasks.Count - 1
         If m_oForm.picTasks(i).Left + m_oForm.picTasks(i).Width > m_oForm.maxX Then
             m_oForm.maxX = m_oForm.picTasks(i).Left + m_oForm.picTasks(i).Width
         End If '
         If m_oForm.picTasks(i).Top + m_oForm.picTasks(i).Height > m_oForm.maxY Then
             m_oForm.maxY = m_oForm.picTasks(i).Top + m_oForm.picTasks(i).Height
         End If
        Next i
        m_oForm.Width = m_oForm.maxX * Screen.TwipsPerPixelX
        m_oForm.Height = m_oForm.maxY * Screen.TwipsPerPixelY
    End If

End Sub
Private Sub removeTask(hwnd As Long)

    Dim i As Integer
    Dim j As Integer
    
    i = 0
    While CLng(m_oForm.picTasks(i).Tag) <> hwnd And i < m_oForm.picTasks.Count - 1
        i = i + 1
    Wend
    If CLng(m_oForm.picTasks(i).Tag) = hwnd Then
        For j = i To m_oForm.picTasks.Count - 2
            m_oForm.picTasks(j).Tag = m_oForm.picTasks(j + 1).Tag
            m_oForm.picTasks_Paint j
        Next j
        Unload m_oForm.picTasks(m_oForm.picTasks.Count - 1)
    End If

End Sub
Private Sub refreshTasks()

    Dim i As Integer
    
    For i = 0 To m_oForm.picTasks.Count - 1
            m_oForm.picTasks_Paint i
    Next i

End Sub
Private Function existTask(hwnd As Long) As Boolean

    Dim i As Long
    
    i = 0
    While CLng(m_oForm.picTasks(i).Tag) <> hwnd And i < m_oForm.picTasks.Count - 1
        i = i + 1
    Wend
    If CLng(m_oForm.picTasks(i).Tag) = hwnd Then
        existTask = True
    Else
        existTask = False
    End If

End Function
